#!/usr/local/bin/perl

############################################
##                                        ##
##                 WebLog                 ##
##           by Darryl Burgdorf           ##
##                                        ##
##           Configuration File           ##
##                                        ##
############################################

require "weblog.pl";

$LogFile = "/illustra/httpd/logs/access_log";
$IPLog = "/illustra/Scripts/ips.txt";

$FileDir = "/illustra/httpd/htdocs/reports";
$ReportFile = "log.html";
$DetailsFile = "log.details.html";
$RefsFile = "log.refs.html";
$KeywordsFile = "log.keys.html";
$AgentsFile = "log.agents.html";

$SystemName = "GIS";

$OrgName = "GIS";
$OrgDomain = "(sandman.npac.syr.edu)";

$GraphURL = "http://sandman.npac.syr.edu:8888/graphs";
$GraphBase = "visits";

# $IncludeOnlyRefsTo = "(includethis|andthis)";
# $ExcludeRefsTo = "(excludethis|andthis)";

# $IncludeOnlyDomain = "";
# $ExcludeDomain = "";

$IncludeQuery = 0;

$PrintFiles = 1;
$Print404 = 1;
$PrintDomains = 0;
$PrintUserIDs = 0;
$PrintTopNFiles = 10;
$TopFileListFilter = "(\.gif|\.jpg|\.jpeg|Code)";
$PrintTopNDomains = 0;

$LogOnlyNew = 1;

$NoSessions = 0;
$NoResolve = 0;

$DetailsFilter = "(\.gif|\.jpg|\.jpeg)";
$DetailsDays = 7;

$refsexcludefrom = "(file:)";
$refsexcludeto = "(\.gif|\.jpg|\.jpeg)";

$RefsStripWWW = 1;
$RefsMinHits = 1;

$AgentsIgnore = "(\.gif|\.jpg|\.jpeg)";

&MainProg;

